//für ausgabe Monitor
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27, 16, 2);
//pins für schnappschalter
#define Schnapp1Pin D5
#define Schnapp2Pin D8
#define Schnapp3Pin D12
//led pins
#define LED_PIN A1 //LED-PIN
//feuchtigkeitssensor pins
#define Moisture1Pin A0 //feuchtigkeitsensor    
#define Moisture2Pin A2
#define Moisture3Pin A3
//Spezielle pins
#define MagnetVentil D7 //Magnetventil
#define PiezoPin D9 //Piezo 
#define WasserstandPin A6 //Wasserstand 
//led
unsigned long zaehlen;
unsigned long zaehlenSek;
int state = -1;
int imSchattenZeit = 3; //Solange darf die Pflanze im Schatten stehen (in Sekunden)
unsigned long LichtAnZeit = 20;  //Solange bleibt die Lampe an (in Sekunden)
unsigned long LichtCooldown = 5;  //Nachdem die Lampe an ist, muss sie solange ausbleiben (in Sekunden)
//schiene
/*pos(position des gießschlauchs) und ziel (ziel des gießschlauchs) sind variablen die global sein müssen,
da sie über den ganzen code da sein müssen und immer wieder vorkommen*/
int pos = 2;
int ziel = 2; // da wo die schiene hinfahren muss


void setup() {
  Serial.begin(9600);
  pinMode(4, OUTPUT); //Hier LED 
  pinMode(7, OUTPUT); //MagnetVentil
  //schiene
  pinMode(3, OUTPUT); // direction pin bei unsere schaltung. 
  pinMode(11, OUTPUT);// bewegungspin
  //ausgabe Monitor
  lcd.init();
  lcd.backlight();
}

void loop() {
  lcd.clear();
  //feuchtigkeitssensoren
  int moisture1Value = measure1Moisture();
  int moisture2Value = measure2Moisture();
  int moisture3Value = measure3Moisture();
  //SCHNAPPSCHALTER
  boolean topf2da = digitalRead(8);
  boolean topf1da = digitalRead(5);
  boolean topf3da = digitalRead(12);
  //so sieht der ausgabe code für den bildschirm aus
  lcd.setCursor(0, 0);
  lcd.print("Topf  1   2   3 ");
  //ab hier wird geschaut welcher Topf da ist welcher Wasser braucht und wohin die Schiene sich bewegen soll
  if (topf1da == true) {
    lcd.setCursor(5, 1);
    lcd.print(" J ");
    moisture1Value = measure1Moisture();
    if (moisture1Value > 500) {
      ziel = 1;
    }
  }
  if (topf2da == true) {
    lcd.setCursor(9, 1);
    lcd.print(" J ");
    moisture2Value = measure2Moisture();
    if (moisture2Value > 500) {
      ziel = 2;
    }
  }
  if (topf3da == true) {
    lcd.setCursor(13, 1);
    lcd.print(" J ");
    moisture3Value = measure3Moisture();
    if (moisture3Value > 500) {
      ziel = 3;
    }
  }
  if (topf1da == false) {
    lcd.setCursor(5, 1);
    lcd.print(" N ");
  }
  if (topf2da == false) {
    lcd.setCursor(9, 1);
    lcd.print(" N ");
  }
  if (topf3da == false) {
    lcd.setCursor(13, 1);
    lcd.print(" N ");
  }

  //Schiene
  // ab hier checkt es alle möglichen Ereignisse die eintreffen können und führt sie mit hilfe der weg funktionen aus
  if (pos == ziel) {
  }
  else if (pos == 2 && ziel == 1) {
    wegeins();
    pos = 1;
  }
  else if (pos == 2 && ziel == 3) {
    wegzwei();
    pos = 3;
  }
  else if (pos == 3 && ziel == 2) {
    wegeins();
    pos = 2;
  }
  else if (pos == 3 && ziel == 1) {
    wegeins();
    wegeins();
    pos = 1;
  }
  else if (pos == 1 && ziel == 2) {
    wegzwei();
    pos = 2;
  }
  else if (pos == 1 && ziel == 3) {
    wegzwei();
    wegzwei();
    pos = 3;
  }
  delay(1000);// auch nur zur überpfrüfung damit man das ausgegebene lesen kann

  //MAGNETVENTIL, WASSERGEBEN & FEUCHTIGKEITSMESSUNGEN
  if (ziel == 1 && moisture1Value > 500) {
    waterGo();
    moisture1Value = measure1Moisture();
  }
  if (ziel == 2 && moisture2Value > 500) {
    waterGo();
    moisture2Value = measure2Moisture();
  }
  if (ziel == 3 && moisture3Value > 500) {
    waterGo();
    moisture3Value = measure3Moisture();
  }
  lcd.setCursor(0, 0);
  lcd.print("Moist 1   2   3 ");
  if (moisture1Value >= 400) {
    lcd.setCursor(5, 1);
    lcd.print("dry");
  }
  if (moisture1Value <= 400) {
    lcd.setCursor(5, 1);
    lcd.print("wet");
  }
  if (moisture2Value >= 400) {
    lcd.setCursor(9, 1);
    lcd.print("dry");
  }
  if (moisture2Value <= 400) {
    lcd.setCursor(9, 1);
    lcd.print("wet");
  }
  if (moisture3Value >= 400) {
    lcd.setCursor(13, 1);
    lcd.print("dry");
  }
  if (moisture3Value <= 400) {
    lcd.setCursor(13, 1);
    lcd.print("wet");
  }
  float wasserstand = wasserstandMessung();
  if (wasserstand >= 100) {
    tone(9, 150);
    delay(2000);
    noTone(9);
    delay(2000);
  }
  //LED
  unsigned long myTime;
  unsigned long myTimeSek;
  int messung = analogRead(A1); //A0 Pin wird gelesen bzw Phototransistor
  if (state == 0 || state == -1) {
    Serial.print("Helligkeit: ");
    Serial.println(messung);
  }
  myTime = millis();  //Laufzeit des Programms wird gezaehlt
  myTimeSek = myTime / 1000;  //Laufzeit wird durch 1000 geteilt, damit es in Sekunden ist
  Serial.print("Laufzeit des Programms: ");
  Serial.println(Timer(myTimeSek));
  if (state != 1 && state != 2) { //Solange das Licht an ist oder der Cooldown laeuft, interessiert es nicht wie hell die Umgebung ist
    if (messung <= 500) { //Wenn es dunkel ist, dann wird das ausgefuehrt
      state = 0;
    }
    else {  //Wenn es hell ist, dann geht es zum default state ueber und der Zaehler wird zurueckgesetzt
      state = -1;
      zaehlen = 0;
    }
  }

  switch (state) {
    case 0: //Dieser Status tritt ein, wenn das Licht aus und es dunkel ist
      lcd.clear();
      Serial.print("Zeit im Schatten: ");
      lcd.setCursor(0, 0);
      lcd.print("Zeit im Schatten");
      lcd.setCursor(0,1);
      lcd.print(zaehlen);
      lcd.setCursor(6,1);
      lcd.print("Sekunden ");
      delay(1000);
      Serial.println(Timer(zaehlen));
      //Wenn es fuer eine bestimmte Anzahl an Sekunden dunkel ist, schalte das Licht an und setze den Zaehler zurueck
      if (zaehlen >= imSchattenZeit) { 
        digitalWrite(4, HIGH);
        zaehlen = 0;
        state = 1;
        break;
      }
      else {
        zaehlen += 1;
        break;
      }
    case 1: //Das Licht ist an und die Dauer wird geprintet
      zaehlen += 1;
      lcd.clear();
      Serial.print("Licht an seit: ");
      lcd.setCursor(0,0);
      lcd.print("Licht an seit:  ");
      lcd.setCursor(0,1);
      lcd.print(zaehlen);
      lcd.setCursor(6,1);
      lcd.print("Sekunden ");
      Serial.println(Timer(zaehlen));
      if (zaehlen >= LichtAnZeit) { //Wenn es eine bestimmte Anzahl an Sekunden erreicht, schaltet sich das Licht aus
        digitalWrite(4, LOW);
        state = 2;
        zaehlen = LichtCooldown;
      }
      break;
    case 2: //Das Licht ist aus und kann fuer eine bestimmte Zeit nicht angehen(Cooldown)
      Serial.print("Lichtcooldown noch: ");
      Serial.println(Timer(zaehlen));
      if (zaehlen > 0) { //Wenn der Cooldown abgelaufen ist, gehe in den default state ueber
        zaehlen -= 1;
      }
      else {
        state = -1;
      }
    default:  //Das Licht ist aus und messung ist ueber 500
      break;
  }
 delay(1000);
}

//in diesen funktionen wird die Feutigkeitgemessen und ein berrechneter Wert zurückgegeben
float measure1Moisture() {
  float measureSum = 0;
  for (int i = 0; i <= 100; i++) {
    measureSum = measureSum + analogRead(Moisture1Pin);
    delay(1);
  }
  return measureSum / 100.0;
}

float measure2Moisture() {
  float measureSum = 0;
  for (int i = 0; i <= 100; i++) {
    measureSum = measureSum + analogRead(Moisture2Pin);
    delay(1);
  }
  return measureSum / 100.0;
}

float measure3Moisture() {
  float measureSum = 0;
  for (int i = 0; i <= 100; i++) {
    measureSum = measureSum + analogRead(Moisture3Pin);
    delay(1);
  }
  return map(measureSum / 100.0, 319, 635, 150, 1023);
}

//hier wird die Zeit umgerechnet das man es besser als user erkennen kann . Und nicht nur Sekunden ausgegeben werden
String Timer(unsigned long _Sek) {
  unsigned long Sek = _Sek;
  int Min = Sek / 60;
  int Std = Min / 60;
  int Tag = Std / 24;
  Sek -= Min * 60;
  Min -= Std * 60;
  Std -= Tag * 24;
  String Time = "";
  if (Tag > 0) {
    Time += String(Tag) + " Tag(e) ";
  }
  if (Std > 0) {
    Time += String(Std) + " Stunde(n) ";
  }
  if (Min > 0) {
    Time += String(Min) + " Minute(n) ";
  }
  Time += String(Sek) + " Sekunde(n) ";
  return Time;
}

//die Funktion für das öffnen des Magnetventils
void waterGo() {
  digitalWrite(7, HIGH);
  delay(1000);
  digitalWrite(7, LOW);
}

float wasserstandMessung() {
  float wasserstandWert = analogRead(WasserstandPin);
  return wasserstandWert;
}

// funktionen für das bewegen,des motors, in jeweils eine richtung ... werte müssen noch rausgefunden werden. der wert i bzw der wert k bestimmt die länge des drehens in eine richtung
void wegeins() {
  digitalWrite(3, HIGH);
  for (int i = 0; i <= 800 ; i++) {
    digitalWrite(11, HIGH);
    delay(2);
    digitalWrite(11, LOW);
    delay(2);
  }
  delay(10);
}

void wegzwei() {
  digitalWrite(3, LOW);
  for (int k = 0; k <= 800 ; k++) {
    digitalWrite(11, HIGH);
    delay(2);
    digitalWrite(11, LOW);
    delay(2);
  }

  delay(10);
}
